.386
.model flat,stdcall
option casemap:none

include Frame.inc

.code
start:
		invoke LoadLibrary,addr szLibName
		mov hLib,eax
		.if eax==0
			invoke MessageBox,NULL,addr szNoLib,addr szAppName,MB_OK or MB_ICONSTOP 
			invoke ExitProcess,0
		.endif
		invoke GetModuleHandle,NULL
		mov hInstance,eax
		invoke InitCommonControls
		invoke WinMain,hInstance,NULL,NULL,SW_SHOWDEFAULT
	    invoke FreeLibrary,hLib
		invoke ExitProcess,eax
		
WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,cmdLine:LPSTR,cmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	
	mov		wc.cbSize,SIZEOF WNDCLASSEX
	mov		wc.style,CS_HREDRAW or CS_VREDRAW
	mov		wc.lpfnWndProc,OFFSET WndProc
	mov		wc.cbClsExtra,NULL
	mov		wc.cbWndExtra,NULL
	push	hInst
	pop		wc.hInstance
	mov		wc.hbrBackground,COLOR_APPWORKSPACE+1
	mov		wc.lpszMenuName,IDR_MAINMENU
	mov		wc.lpszClassName,OFFSET szClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov		wc.hIcon,eax
	mov		wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov		wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	
	mov		wc.lpfnWndProc,OFFSET ChildProc
	mov		wc.hbrBackground,NULL
	mov		wc.lpszClassName,OFFSET szChildClass
	mov		wc.cbWndExtra,4
	mov		wc.lpszMenuName,IDR_CHILDMENU
	invoke RegisterClassEx,addr wc
	invoke CreateWindowEx,NULL,addr szClassName,addr szAppName,\
					WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN,
					CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,\
					CW_USEDEFAULT,NULL,0,hInst,NULL	
	mov hFrame,eax				
	invoke LoadMenu,hInst,IDR_CHILDMENU
	mov hChildMenu,eax
	invoke ShowWindow,hFrame,SW_MAXIMIZE
	invoke UpdateWindow,hFrame
	.while TRUE
			invoke GetMessage,addr msg,NULL,0,0
	  		.break .if !eax
			invoke TranslateMDISysAccel,hClient,addr msg
			.if !eax
				invoke TranslateMessage,addr msg
				invoke DispatchMessage,addr msg
			.endif
	.endw
	invoke DestroyMenu,hChildMenu
	mov	eax,msg.wParam

	ret
WinMain endp
WndProc proc hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
	LOCAL clientStrc	:CLIENTCREATESTRUCT
	LOCAL rcClFrame		:RECT
	LOCAL rcTlbar		:RECT
	LOCAL rcStatus		:RECT
	LOCAL ptTlbar		:POINT
	LOCAL ptStatus		:POINT
	.if uMsg==WM_CREATE
		invoke GetMenu,hWnd
		mov hMainMenu,eax
		invoke GetSubMenu,hMainMenu,4
		mov clientStrc.hWindowMenu,eax
		mov clientStrc.idFirstChild,401
		invoke CreateWindowEx,WS_EX_CLIENTEDGE,addr szClientName,NULL,\
						WS_CHILD or WS_VISIBLE or WS_CLIPCHILDREN ,\
						CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,\
						CW_USEDEFAULT,hWnd,NULL,hInstance,addr clientStrc
		mov hClient,eax
		
		mov mdiCreate.szClass,offset szChildClass
		mov mdiCreate.szTitle,offset szChildTitle
		push hInstance
		pop mdiCreate.hOwner
		mov mdiCreate.style,WS_CLIPCHILDREN or WS_CLIPSIBLINGS 
		mov mdiCreate.x,CW_USEDEFAULT
		mov mdiCreate.y,CW_USEDEFAULT
		mov mdiCreate.lx,CW_USEDEFAULT
		mov mdiCreate.ly,CW_USEDEFAULT
		invoke CreateToolbarEx, hWnd, WS_CHILD or \
					WS_CLIPCHILDREN or WS_CLIPSIBLINGS or \
					TBSTYLE_TOOLTIPS or CCS_TOP,ID_TOOLBAR, \
					1, hInstance,IDB_TOOLBAR, \
					addr tbb,22, 16, 16, 16, 16, sizeof TBBUTTON
		mov hToolbar,eax
		push edi
		mov edi,208
		TbrLoop:
			invoke SendMessage,hToolbar,TB_ENABLEBUTTON,edi,FALSE
			inc edi
			cmp edi,220
			jbe TbrLoop
		pop edi
    	invoke SendMessage,hToolbar,TB_SETSTYLE,0,TBSTYLE_FLAT or CCS_TOP
    	invoke ShowWindow,hToolbar,TRUE
		invoke CreateStatus,hWnd
;---------------------------------------------------------------			
	.elseif uMsg==WM_COMMAND
		push ebx
		ASSUME ebx:PTR GRIDDATA
		mov eax,wParam
		.if ax==IDM_FILE_EXIT
			invoke SendMessage,hWnd,WM_CLOSE,0,0
		.elseif ax==IDM_WIN_TILEHORZ
			invoke SendMessage,hClient,WM_MDITILE,MDITILE_HORIZONTAL,0 
		.elseif ax==IDM_WIN_TILEVERT
			invoke SendMessage,hClient,WM_MDITILE,MDITILE_VERTICAL,0
		.elseif ax==IDM_WIN_CASCADE
			invoke SendMessage,hClient,WM_MDICASCADE,MDITILE_SKIPDISABLED,0
		.elseif ax==IDM_FILE_NEW
			invoke SendMessage,hClient,WM_MDICREATE,0,addr mdiCreate 
		.elseif ax==IDM_FILE_OPEN
			invoke MessageBox,NULL,addr szNoWork,addr szAppName,MB_OK
		.elseif ax==IDM_FILE_SAVE
			invoke MessageBox,NULL,addr szNoWork,addr szAppName,MB_OK
		.elseif ax==IDM_FILE_SAVEAS
			
		.elseif ax==IDM_VIEW_TOOLBAR
			
		.elseif ax==IDM_VIEW_STATUS
			
		.elseif ax==IDM_FILE_CLOSE
			invoke SendMessage,hClient,WM_MDIGETACTIVE,0,0
			mov edx,eax
			invoke SendMessage,edx,WM_CLOSE,0,0
		.elseif ax==IDM_FILE_PREVIEW
			invoke MessageBox,NULL,addr szNoWork,addr szAppName,MB_OK
		.elseif ax==IDM_FILE_PRINT
			invoke MessageBox,NULL,addr szNoWork,addr szAppName,MB_OK
		.elseif ax==IDM_EDIT_CUT
			invoke MessageBox,NULL,addr szNoWork,addr szAppName,MB_OK
		.elseif ax==IDM_EDIT_COPY
			invoke MessageBox,NULL,addr szNoWork,addr szAppName,MB_OK
		.elseif ax==IDM_EDIT_PASTE
			invoke MessageBox,NULL,addr szNoWork,addr szAppName,MB_OK
		.elseif ax==IDM_FORMAT_BOLD
			invoke MessageBox,NULL,addr szNoWork,addr szAppName,MB_OK
		.elseif ax==IDM_FORMAT_ITALIC
			invoke MessageBox,NULL,addr szNoWork,addr szAppName,MB_OK
		.elseif ax==IDM_FORMAT_UNDERLINE
			invoke MessageBox,NULL,addr szNoWork,addr szAppName,MB_OK
		.elseif ax==IDM_FORMAT_LEFT
			invoke MessageBox,NULL,addr szNoWork,addr szAppName,MB_OK
		.elseif ax==IDM_FORMAT_CENTER
			invoke MessageBox,NULL,addr szNoWork,addr szAppName,MB_OK
		.elseif ax==IDM_FORMAT_RIGHT
			invoke MessageBox,NULL,addr szNoWork,addr szAppName,MB_OK
		.elseif ax==IDM_FORMAT_VCENTER
			invoke MessageBox,NULL,addr szNoWork,addr szAppName,MB_OK
		.elseif ax==IDM_FORMAT_COL	
			invoke DialogBoxParam,hInstance, addr szFormColsDlg,\
							hClient,offset DlgFormColsProc,NULL
		.elseif ax==IDM_FORMAT_ROW	
			invoke DialogBoxParam,hInstance, addr szFormRowsDlg,\
							hClient,offset DlgFormRowsProc,NULL
		.elseif ax==IDM_FORMAT_GRIDCOLOR
			invoke SendMessage,hClient,WM_MDIGETACTIVE,0,0
			invoke GetWindowLong,eax,0		
			mov ebx,eax
			invoke SendMessage,[ebx].hGrid,GM_GETGRIDCOLOR,0,0
			invoke SelectColor,hWnd,eax							
			invoke SendMessage,[ebx].hGrid,GM_SETGRIDCOLOR,eax,0
		.elseif ax==IDM_FORMAT_BKCOLOR
			invoke SendMessage,hClient,WM_MDIGETACTIVE,0,0
			invoke GetWindowLong,eax,0		
			mov ebx,eax
			invoke SendMessage,[ebx].hGrid,GM_GETBKCOLOR,0,0
			invoke SelectColor,hWnd,eax							
			invoke SendMessage,[ebx].hGrid,GM_SETBKCOLOR,eax,0
		.elseif ax==IDM_FORMAT_CELLS
			;......................
		.elseif ax==IDM_HELP_ABOUT
			invoke DialogBoxParam,hInstance, addr szAboutDlg,hWnd,offset AboutDlgProc,NULL
		.else
			invoke DefFrameProc,hWnd,hClient,uMsg,wParam,lParam	
			pop ebx
			ret
		.endif
		pop ebx
;---------------------------------------------------------------			
	.elseif uMsg==WM_SIZE
		.if hClient!=NULL
			invoke GetClientRect,hWnd,addr rcClFrame
			invoke SendMessage,hToolbar,TB_AUTOSIZE,0,0
			invoke MoveWindow,hStatus,0,0,0,0,TRUE
			invoke GetWindowRect,hToolbar,addr rcTlbar
			invoke GetWindowRect,hStatus,addr rcStatus
			mov ptStatus.x,0
			mov ptTlbar.x,0
			push rcStatus.top
			pop ptStatus.y
			invoke ScreenToClient,hWnd,addr ptStatus
			push rcTlbar.bottom
			pop ptTlbar.y
			invoke ScreenToClient,hWnd,addr ptTlbar
			mov eax,ptStatus.y
			sub eax,ptTlbar.y             ;eax=MDIClient height
			mov edx,eax
			invoke MoveWindow,hClient,0,ptTlbar.y,\
								rcClFrame.right,edx,TRUE
		.endif
;---------------------------------------------------------------			
	.elseif uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL		
;---------------------------------------------------------------			
	.else
		invoke DefFrameProc,hWnd,hClient,uMsg,wParam,lParam		
		ret
	.endif
	xor eax,eax
	ret
WndProc endp
ChildProc proc hChild:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
	LOCAL szBuffer[128] :BYTE
	LOCAL szTitle[128]	:BYTE
	LOCAL szText[256]	:DWORD
	LOCAL nWidth		:DWORD
	LOCAL nHeight		:DWORD
	LOCAL rcCell		:RECT
	LOCAL infCell		:CELLINFO
	LOCAL ColRow		:DWORD
	LOCAL topRow		:DWORD
	LOCAL bottomRow		:DWORD
	LOCAL leftCol		:DWORD
	LOCAL rightCol		:DWORD
	
	push ebx
	ASSUME ebx:PTR GRIDDATA
	.if uMsg==WM_MDIACTIVATE
		mov eax,lParam
		.if eax==hChild
			invoke GetSubMenu,hChildMenu,4
			mov edx,eax
			invoke SendMessage,hClient,WM_MDISETMENU,hChildMenu,edx
			push edi
			mov edi,208
			TbrLoop1:
				invoke SendMessage,hToolbar,TB_ENABLEBUTTON,edi,TRUE
				inc edi
				cmp edi,220
				jbe TbrLoop1
			pop edi
			invoke GetWindowLong,hChild,0	
			invoke SetFocus,eax		;eax=hGrid
		.else
			invoke GetSubMenu,hMainMenu,4   
			mov edx,eax 
			invoke SendMessage,hClient,WM_MDISETMENU,hMainMenu,edx 
			push edi
			mov edi,208
			TbrLoop2:
				invoke SendMessage,hToolbar,TB_ENABLEBUTTON,edi,FALSE
				inc edi
				cmp edi,220
				jbe TbrLoop2
			pop edi
		.endif
		invoke DrawMenuBar,hFrame 
;------------------------------------------------------------	
	.elseif uMsg==WM_CREATE
		invoke GlobalAlloc,GPTR,sizeof GRIDDATA
		mov ebx,eax      
		invoke SetWindowLong,hChild,0,ebx  
		push esi
		lea ecx,szTitle
		invoke strCopy,ecx,addr szChildTitle
		invoke GetWindowLong,hChild,GWL_ID 
		mov esi,eax		;esi=ID of Grid
		sub eax,400
		lea edx,szBuffer
		invoke dwtoa,eax,edx
		invoke szCatStr,addr szTitle,addr szBuffer
		invoke SetWindowText,hChild,addr szTitle
		
		invoke CreateWindowEx,WS_EX_CLIENTEDGE,addr szGridName,NULL,\
		                      WS_CHILD or WS_VISIBLE or WS_CLIPCHILDREN,\
		                      0,0,150,100,hChild,esi,hInstance,NULL
		mov [ebx].hGrid,eax		;store hGrid
		invoke CreateWindowEx,NULL,addr szEditClass,NULL,\
		                      WS_CHILD or ES_MULTILINE,\
		                      0,0,24,19,[ebx].hGrid,esi,hInstance,NULL
		mov [ebx].hEdit,eax    ;store hEdit                   
        invoke CreateFont,14,0,0,0,400,0,0,0,ANSI_CHARSET,\ 
                             OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,\ 
                             DEFAULT_QUALITY,DEFAULT_PITCH or FF_SCRIPT,\ 
                             addr szFontName
        mov hFont,eax    
		invoke SendMessage,[ebx].hGrid,WM_SETFONT,hFont,0
		invoke SendMessage,[ebx].hEdit,WM_SETFONT,hFont,0
		mov esi,1
		colsLoop:
			MAKEDWORD si,0
			invoke SendMessage,[ebx].hGrid,GM_SETCELLALIGN,eax,CENTER_CENTER
			inc esi
			cmp esi,5
			jne colsLoop
		mov esi,1
		rowsLoop:
			MAKEDWORD 0,si
			invoke SendMessage,[ebx].hGrid,GM_SETCELLALIGN,eax,CENTER_CENTER
			inc esi
			cmp esi,4
			jne rowsLoop
		invoke CountCols,[ebx].hGrid,5
		invoke CountRows,[ebx].hGrid,4
		pop esi
;-----------------------------------------------------------------
	.elseif uMsg==WM_SIZE
		LOWORD lParam
		mov nWidth,eax
		HIWORD lParam
		mov nHeight,eax
		invoke GetWindowLong,hChild,0
		.if eax
			mov ebx,eax
			invoke MoveWindow,[ebx].hGrid,0,0,nWidth,nHeight,TRUE	
			invoke DefMDIChildProc,hChild,uMsg,wParam,lParam 
		.endif  
		pop ebx
		ret 
;-----------------------------------------------------------------
    .elseif uMsg==WM_SIZING
		invoke GetWindowLong,hChild,0
		mov ebx,eax
		invoke SendMessage,[ebx].hGrid,GM_SIZING,wParam,lParam
		pop ebx
        mov eax,TRUE 
        ret   
;-----------------------------------------------------------------
	.elseif uMsg==WM_CLOSE
		invoke MessageBox,NULL,addr szClosePrompt,addr szAppName,MB_YESNOCANCEL or MB_ICONQUESTION 
		.if eax==IDYES
			invoke MessageBox,NULL,addr szNoWork,addr szAppName,MB_OK
			invoke SendMessage,hClient,WM_MDIDESTROY,hChild,0 
		.elseif eax==IDNO
			invoke SendMessage,hClient,WM_MDIDESTROY,hChild,0 
		.endif
;-----------------------------------------------------------------
	.elseif uMsg==WM_DESTROY
		invoke GetWindowLong,hChild,0
		mov ebx,eax	
		invoke DestroyWindow,[ebx].hGrid
		invoke GlobalFree,ebx         
;-----------------------------------------------------------------
	.elseif uMsg==GM_RTCLK
		invoke MessageBox,NULL,addr szNoWork,addr szAppName,MB_OK
		
;-----------------------------------------------------------------
	.elseif uMsg==GM_DBLCLK
		invoke GetWindowLong,hChild,0
		mov ebx,eax
		invoke ShowWindow,[ebx].hEdit,SW_SHOW
		invoke SetFocus,[ebx].hEdit
		mov [ebx].bEdit,TRUE
;-----------------------------------------------------------------
	.elseif uMsg==GM_LEAVECELL
		invoke GetWindowLong,hChild,0
		mov ebx,eax
		invoke ShowWindow,[ebx].hEdit,SW_HIDE
		mov [ebx].bEdit,FALSE
		invoke GetWindowText,[ebx].hEdit,addr szText,255
		invoke SendMessage,[ebx].hGrid,GM_GETCELLINFO,addr infCell,addr rcCell
		mov edx,eax	;LOWORD(eax)=current Column,HIWORD(eax)=current Row
		invoke SendMessage,[ebx].hGrid,GM_SETCELLTEXT,edx,addr szText
		invoke EmptyBuffer,addr szText,256
		invoke SetWindowText,[ebx].hEdit,addr szText
;-----------------------------------------------------------------
	.elseif uMsg==GM_ENTERCELL
		invoke GetWindowLong,hChild,0
		mov ebx,eax
		invoke SendMessage,[ebx].hGrid,GM_GETCELLINFO,addr infCell,addr rcCell
		mov eax,rcCell.right
		sub eax,rcCell.left
		mov edx,rcCell.bottom
		sub edx,rcCell.top	
		invoke MoveWindow,[ebx].hEdit,rcCell.left,rcCell.top,eax,edx,TRUE
		invoke SendMessage,[ebx].hGrid,GM_GETCELLINFO,addr infCell,addr rcCell
		mov edx,eax	;LOWORD(eax)=current Column,HIWORD(eax)=current Row
		invoke SendMessage,[ebx].hGrid,GM_GETCELLTEXT,edx,addr szText
		dec rcCell.left
		inc rcCell.top
		dec rcCell.right
		inc rcCell.bottom
		invoke SendMessage,[ebx].hEdit,WM_SETTEXT,255,addr szText
;-----------------------------------------------------------------
	.elseif uMsg==GM_SCROLL
		invoke GetWindowLong,hChild,0
		mov ebx,eax
		.if [ebx].bEdit==TRUE
			invoke SendMessage,[ebx].hGrid,GM_GETCELLINFO,addr infCell,addr rcCell
			mov ColRow,eax
			.if lParam==1		;Scroll vertical
				invoke SendMessage,[ebx].hGrid,GM_GETTOPROW,0,0
				mov topRow,eax
				invoke SendMessage,[ebx].hGrid,GM_GETBOTTOMROW,0,0
			 	mov bottomRow,eax
			 	HIWORD ColRow
			 	.if eax<topRow || eax>bottomRow
					invoke ShowWindow,[ebx].hEdit,SW_HIDE	
			 	.elseif eax==topRow || eax==bottomRow
					mov eax,rcCell.right
					sub eax,rcCell.left
					mov edx,rcCell.bottom
					sub edx,rcCell.top
					invoke MoveWindow,[ebx].hEdit,rcCell.left,rcCell.top,eax,edx,TRUE
					invoke ShowWindow,[ebx].hEdit,SW_SHOW
					invoke SetFocus,[ebx].hEdit
				.endif
			.elseif lParam==2	;Scroll horzondal
				invoke SendMessage,[ebx].hGrid,GM_GETLEFTCOL,0,0
				mov leftCol,eax
				invoke SendMessage,[ebx].hGrid,GM_GETRIGHTCOL,0,0
			 	mov rightCol,eax
			 	LOWORD ColRow
			 	.if eax<leftCol || eax>rightCol
					invoke ShowWindow,[ebx].hEdit,SW_HIDE	
			 	.elseif eax==leftCol || eax==rightCol
					mov eax,rcCell.right
					sub eax,rcCell.left
					mov edx,rcCell.bottom
					sub edx,rcCell.top
					invoke MoveWindow,[ebx].hEdit,rcCell.left,rcCell.top,eax,edx,TRUE
					invoke ShowWindow,[ebx].hEdit,SW_SHOW
					invoke SetFocus,[ebx].hEdit
				.endif
			.endif
		.endif
;-----------------------------------------------------------------
	.else 	
		invoke DefMDIChildProc,hChild,uMsg,wParam,lParam 
		ASSUME ebx:nothing
		pop ebx
		ret 
	.endif
	pop ebx
	xor eax,eax
	ret
ChildProc endp
DlgFormColsProc proc hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
	LOCAL numCols	:DWORD
	LOCAL firstCol	:DWORD
	LOCAL lastCol	:DWORD
	LOCAL colWidth	:DWORD
	push ebx
	ASSUME ebx:PTR GRIDDATA
	.if uMsg==WM_INITDIALOG
		invoke SendMessage,hClient,WM_MDIGETACTIVE,0,0
		invoke GetWindowLong,eax,0		
		mov ebx,eax
		invoke SendMessage,[ebx].hGrid,GM_GETCOLS,0,0
		invoke SetDlgItemInt,hWnd,IDC_EDIT_NUMCOLS,eax,FALSE
		invoke SendMessage,[ebx].hGrid,GM_GETCOL,0,0
		invoke SendMessage,[ebx].hGrid,GM_GETCOLWIDTH,eax,0
		invoke SetDlgItemInt,hWnd,IDC_EDIT_COLWIDTH,eax,FALSE
;----------------------------------------------------------------------		
	.elseif uMsg==WM_CLOSE
		invoke EndDialog,hWnd,NULL
;----------------------------------------------------------------------		
	.elseif uMsg==WM_COMMAND
		mov eax,wParam
		mov edx,eax
		shr edx,16
		.if dx==BN_CLICKED
			push edi
			.if eax==IDC_BTN_OK_COLS
				invoke GetDlgItemInt,hWnd,IDC_EDIT_NUMCOLS,NULL,FALSE
				mov numCols,eax
				invoke SendMessage,hClient,WM_MDIGETACTIVE,0,0
				invoke GetWindowLong,eax,0		
				mov ebx,eax
				.if numCols>2 && numCols<255
					invoke SendMessage,[ebx].hGrid,GM_SETCOLS,numCols,0
					mov edi,1
					colsLoop1:
						MAKEDWORD di,0
						invoke SendMessage,[ebx].hGrid,GM_SETCELLALIGN,eax,CENTER_CENTER
						inc edi
						cmp edi,numCols
						jne colsLoop1
					invoke CountCols,[ebx].hGrid,numCols
				.else
					invoke MessageBox,NULL,addr szErrorCols,\
										addr szAppName,MB_OK
				.endif
				invoke SendMessage,[ebx].hGrid,GM_GETCOL,0,0
				mov firstCol,eax
				invoke SendMessage,[ebx].hGrid,GM_GETCOLSEL,0,0
				.if firstCol<=eax		;eax=ColSel
					mov lastCol,eax
				.else
					mov edx,firstCol
					mov lastCol,edx
					mov firstCol,eax
				.endif		
				invoke GetDlgItemInt,hWnd,IDC_EDIT_COLWIDTH,NULL,FALSE
				mov colWidth,eax
				mov edi,firstCol
				colsLoop2:
					invoke SendMessage,[ebx].hGrid,GM_SETCOLWIDTH,edi,colWidth
					inc edi
					cmp edi,lastCol
					jbe colsLoop2
			.endif
			pop edi	
			invoke SendMessage,hWnd,WM_CLOSE,NULL,NULL
		.endif
;----------------------------------------------------------------------		
	.else
		pop ebx
		mov eax,FALSE
		ret
	.endif
	pop ebx
	mov  eax,TRUE
	ret
DlgFormColsProc endp
DlgFormRowsProc proc hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
	LOCAL numRows	:DWORD
	LOCAL firstRow	:DWORD
	LOCAL lastRow	:DWORD
	LOCAL rowHeight	:DWORD
	push ebx
	ASSUME ebx:PTR GRIDDATA
	.if uMsg==WM_INITDIALOG
		invoke SendMessage,hClient,WM_MDIGETACTIVE,0,0
		invoke GetWindowLong,eax,0		
		mov ebx,eax
		invoke SendMessage,[ebx].hGrid,GM_GETROWS,0,0
		invoke SetDlgItemInt,hWnd,IDC_EDIT_NUMROWS,eax,FALSE
		invoke SendMessage,[ebx].hGrid,GM_GETROW,0,0
		invoke SendMessage,[ebx].hGrid,GM_GETROWHEIGHT,eax,0
		invoke SetDlgItemInt,hWnd,IDC_EDIT_ROWHEIGHT,eax,FALSE
;----------------------------------------------------------------------		
	.elseif uMsg==WM_CLOSE
		invoke EndDialog,hWnd,NULL
;----------------------------------------------------------------------		
	.elseif uMsg==WM_COMMAND
		mov eax,wParam
		mov edx,eax
		shr edx,16
		.if dx==BN_CLICKED
			push edi
			.if eax==IDC_BTN_OK_ROWS
				invoke GetDlgItemInt,hWnd,IDC_EDIT_NUMROWS,NULL,FALSE
				mov numRows,eax
				invoke SendMessage,hClient,WM_MDIGETACTIVE,0,0
				invoke GetWindowLong,eax,0		
				mov ebx,eax
				.if numRows>2 && numRows<16383
					invoke SendMessage,[ebx].hGrid,GM_SETROWS,numRows,0
					mov edi,1
					rowsLoop1:
						MAKEDWORD 0,di
						invoke SendMessage,[ebx].hGrid,GM_SETCELLALIGN,eax,CENTER_CENTER
						inc edi
						cmp edi,numRows
						jne rowsLoop1
					invoke CountRows,[ebx].hGrid,numRows
				.else
					invoke MessageBox,NULL,addr szErrorRows,\
										addr szAppName,MB_OK
				.endif
				invoke SendMessage,[ebx].hGrid,GM_GETROW,0,0
				mov firstRow,eax
				invoke SendMessage,[ebx].hGrid,GM_GETROWSEL,0,0
				.if firstRow<=eax		;eax=RowSel
					mov lastRow,eax
				.else
					mov edx,firstRow
					mov lastRow,edx
					mov firstRow,eax
				.endif		
				invoke GetDlgItemInt,hWnd,IDC_EDIT_ROWHEIGHT,NULL,FALSE
				mov rowHeight,eax
				mov edi,firstRow
				rowsLoop2:
					invoke SendMessage,[ebx].hGrid,GM_SETROWHEIGHT,edi,rowHeight
					inc edi
					cmp edi,lastRow
					jbe rowsLoop2
			.endif
			pop edi	
			invoke SendMessage,hWnd,WM_CLOSE,NULL,NULL
		.endif
;----------------------------------------------------------------------		
	.else
		pop ebx
		mov eax,FALSE
		ret
	.endif
	pop ebx
	mov  eax,TRUE
	ret
DlgFormRowsProc endp
AboutDlgProc proc hWin:HWND,iMsg:DWORD,wParam:WPARAM, lParam:LPARAM
	.if iMsg==WM_INITDIALOG
		
	.elseif iMsg==WM_CLOSE
		invoke EndDialog,hWin,NULL
	.elseif iMsg==WM_COMMAND
		mov eax,wParam
		mov edx,eax
		shr edx,16
		.if dx==BN_CLICKED
			.if eax==IDC_BTN_OK_ABOUT
				invoke SendMessage,hWin,WM_CLOSE,NULL,NULL
			.endif
		.endif
	.else
		mov eax,FALSE
		ret
	.endif
	mov  eax,TRUE
	ret
AboutDlgProc endp


include Misc.asm

end start



